note
	description: "[
		Elements that represent items of a list.
		]"
	author: "Bernhard Brodowsky, Severin Heiniger and Stefan Heule"
	date: "$Date$"
	revision: "$Revision$"

class
	EDL_LIST_ITEM

inherit
	EDL_COMPOUND_ELEMENT [EDL_AUTONOMOUS_ELEMENT]

create
	default_create,
	make_from_element,
	make_from_elements,
	make_simple

feature {NONE} -- Initialization

	make_simple (a_string: STRING)
			-- Initialize with a paragraph containing only a text element with
			-- `a_string' as content.
		require
			string_is_utf8: (create {EDL_UTF8_ENCODING}).is_valid (a_string)
		do
			default_create
			extend_simple (a_string)
		ensure
			correct_count: count = 1
		end

feature -- Element change

	extend_simple (a_string: STRING)
			-- Add a paragraph containing only a text element with
			-- `a_string' as content.
		require
			string_is_utf8: (create {EDL_UTF8_ENCODING}).is_valid (a_string)
		do
			extend (create {EDL_PARAGRAPH}.make_simple (a_string))
		ensure
			correct_count: count = old count + 1
		end

feature -- Miscellaneous

	accept (a_visitor: EDL_VISITOR)
			-- Accept `a_visitor' and pass it on to the children.
		do
			a_visitor.visit_list_item (Current)
			accept_children (a_visitor)
			a_visitor.leave_list_item (Current)
		end

end
