note
	description: "[
		Paragraphs are the only way to include inline elements in documents.
		]"
	author: "Bernhard Brodowsky, Severin Heiniger and Stefan Heule"
	date: "$Date$"
	revision: "$Revision$"

class
	EDL_PARAGRAPH

inherit
	EDL_COMPOUND_ELEMENT [EDL_INLINE_ELEMENT]

	EDL_AUTONOMOUS_ELEMENT
		undefine
			default_create,
			has
		end

create
	default_create,
	make_from_element,
	make_from_elements,
	make_simple

feature -- Initialization

	make_simple (a_string: STRING)
			-- Initialize with a text element with `a_string' as content.
		require
			string_is_utf8: (create {EDL_UTF8_ENCODING}).is_valid (a_string)
		do
			default_create
			extend_simple (a_string)
		ensure
			correct_count: count = 1
		end

feature -- Element change

	extend_simple (a_string: STRING)
			-- Add a text element with `a_string' as content.
		require
			string_is_utf8: (create {EDL_UTF8_ENCODING}).is_valid (a_string)
		do
			extend (create {EDL_TEXT_ELEMENT}.make (a_string))
		ensure
			correct_count: count = old count + 1
		end

feature -- Miscellaneous

	accept (a_visitor: EDL_VISITOR)
			-- Accept `a_visitor' and pass it on to the children.
		do
			a_visitor.visit_paragraph (Current)
			accept_children (a_visitor)
			a_visitor.leave_paragraph (Current)
		end

end
