note
	description: "[
		Elements with a non-unique name. 
		Clients may generate a unique identifier for each element in a list of
		identifiable elements based on their names using EDL_IDENTIFIER_GENERATOR.
		]"
	author: "Bernhard Brodowsky, Severin Heiniger and Stefan Heule"
	date: "$Date$"
	revision: "$Revision$"

deferred class
	EDL_IDENTIFIABLE_ELEMENT

inherit
	EDL_ELEMENT

feature -- Access

	name: STRING
			-- Name of the element. Does not need to be unique.
		deferred
		end

feature -- Comparison

	use_same_identifier (a_other: like Current): BOOLEAN
			-- Is it ok to use the same identifier for both `Current'
			-- and `a_other'?
		do
			Result := Current = a_other -- Never use the same identifier for two different objects
		ensure
			only_if_same_name: Result implies name.is_equal (a_other.name)
			symmetric: Result = a_other.use_same_identifier (Current)
		end

end
