note
	description: "Summary description for {EDL_LISTING}."
	author: ""
	date: "$Date$"
	revision: "$Revision$"

class
	EDL_LISTING

inherit
	EDL_AUTONOMOUS_ELEMENT

create
	make

feature {NONE} -- Initialization

	make (a_language, a_string: STRING)
			-- Initialize `language' with `a_language' and `content' with `a_string'.
		do
			language := a_language
			content := a_string
		ensure
			content_set: content.is_equal (a_string)
			language_set: language.is_equal (a_language)
		end

feature -- Access

	language: STRING assign set_language
			-- Language of the listing or empty string if no syntax highlighting
			-- is needed.

	content: STRING assign set_content
			-- Listing content.

feature -- Element change

	set_language (a_language: STRING)
			-- Change `language' to `a_language'.
		do
			language := a_language
		ensure
			language_set: language.is_equal (a_language)
		end

	set_content (a_string: STRING)
			-- Change `content' to `a_string'.
		do
			content := a_string
		ensure
			content_set: content.is_equal (a_string)
		end

feature -- Miscellaneous

	accept (a_visitor: EDL_VISITOR)
			-- Accept `a_visitor'.
		do
			a_visitor.visit_listing (Current)
			a_visitor.leave_listing (Current)
		end

end
