note
	description: "[
		Elements whose content is directly copied to the output.
		]"
	author: "Bernhard Brodowsky, Severin Heiniger and Stefan Heule"
	date: "$Date$"
	revision: "$Revision$"

class
	EDL_RAW_ELEMENT

inherit
	EDL_AUTONOMOUS_ELEMENT

	EDL_INLINE_ELEMENT

create
	make

feature {NONE} -- Initialization

	make (a_string: STRING)
			-- Initialize `content' with `a_string'.
		do
			content := a_string
		ensure
			content_set: content.is_equal (a_string)
		end

feature -- Access

	content: STRING assign set_content

feature -- Element change

	set_content (a_string: STRING)
			-- Change `content' to `a_string'.
		do
			content := a_string
		ensure
			content_set: content.is_equal (a_string)
		end

feature -- Miscellaneous

	accept (a_visitor: EDL_VISITOR)
			-- Accept `a_visitor'.
		do
			a_visitor.visit_raw_element (Current)
			a_visitor.leave_raw_element (Current)
		end

end
