note
	description: "[
		Objects that perform an operation on each element in a document.
		]"
	author: "Bernhard Brodowsky, Severin Heiniger and Stefan Heule"
	date: "$Date$"
	revision: "$Revision$"

deferred class
	EDL_VISITOR

feature {EDL_VISITABLE} -- Visitor

	visit_text_element (a_text_element: EDL_TEXT_ELEMENT)
			-- Visit `a_text_element'.
		deferred
		end

	leave_text_element (a_text_element: EDL_TEXT_ELEMENT)
			-- Leave `a_text_element'.
		deferred
		end

	visit_table (a_table: EDL_TABLE)
			-- Visit `a_table'.
		deferred
		end

	leave_table (a_table: EDL_TABLE)
			-- Leave `a_table'.
		deferred
		end

	visit_table_row (a_table_row: EDL_TABLE_ROW)
			-- Visit `a_table_row'.
		deferred
		end

	leave_table_row (a_table_row: EDL_TABLE_ROW)
			-- Leave `a_table_row'.
		deferred
		end

	visit_table_cell (a_table_cell: EDL_TABLE_CELL)
			-- Visit `a_table_cell'.
		deferred
		end

	leave_table_cell (a_table_cell: EDL_TABLE_CELL)
			-- Leave `a_table_cell'.
		deferred
		end

	visit_alphabetic_list (a_alphabetic_list: EDL_ALPHABETIC_LIST)
			-- Visit `a_alphabetic_list'.
		deferred
		end

	leave_alphabetic_list (a_alphabetic_list: EDL_ALPHABETIC_LIST)
			-- Leave `a_alphabetic_list'.
		deferred
		end

	visit_arabic_list (a_arabic_list: EDL_ARABIC_LIST)
			-- Visit `a_arabic_list'.
		deferred
		end

	leave_arabic_list (a_arabic_list: EDL_ARABIC_LIST)
			-- Leave `a_arabic_list'.
		deferred
		end

	visit_bullet_list (a_bullet_list: EDL_BULLET_LIST)
			-- Visit `a_bullet_list'.
		deferred
		end

	leave_bullet_list (a_bullet_list: EDL_BULLET_LIST)
			-- Leave `a_bullet_list'.
		deferred
		end

	visit_roman_list (a_roman_list: EDL_ROMAN_LIST)
			-- Visit `a_roman_list'.
		deferred
		end

	leave_roman_list (a_roman_list: EDL_ROMAN_LIST)
			-- Leave `a_roman_list'.
		deferred
		end

	visit_list_item (a_list_item: EDL_LIST_ITEM)
			-- Visit `a_list_item'.
		deferred
		end

	leave_list_item (a_list_item: EDL_LIST_ITEM)
			-- Leave `a_list_item'.
		deferred
		end

	visit_section (a_section: EDL_SECTION)
			-- Visit `a_section'.
		deferred
		end

	leave_section (a_section: EDL_SECTION)
			-- Leave `a_section'.
		deferred
		end

	visit_image (a_image: EDL_IMAGE)
			-- Visit `a_image'.
		deferred
		end

	leave_image (a_image: EDL_IMAGE)
			-- Leave `a_image'.
		deferred
		end

	visit_paragraph (a_paragraph: EDL_PARAGRAPH)
			-- Visit `a_paragraph'.
		deferred
		end

	leave_paragraph (a_paragraph: EDL_PARAGRAPH)
			-- Leave `a_paragraph'.
		deferred
		end

	visit_reference (a_reference: EDL_REFERENCE)
			-- Visit `a_reference'.
		deferred
		end

	leave_reference (a_reference: EDL_REFERENCE)
			-- Leave `a_reference'.
		deferred
		end

	visit_table_of_contents (a_table_of_contents: EDL_TABLE_OF_CONTENTS)
			-- Visit a `a_table_of_contents'.
		deferred
		end

	leave_table_of_contents (a_table_of_contents: EDL_TABLE_OF_CONTENTS)
			-- Leave a `a_table_of_contents'.
		deferred
		end

	visit_raw_element (a_raw_element: EDL_RAW_ELEMENT)
			-- Visit a `a_raw_element'.
		deferred
		end

	leave_raw_element (a_raw_element: EDL_RAW_ELEMENT)
			-- Leave a `a_raw_element'.
		deferred
		end

	visit_listing (a_listing: EDL_LISTING)
			-- Visit a `a_listing'.
		deferred
		end

	leave_listing (a_listing: EDL_LISTING)
			-- Leave a `a_listing'.
		deferred
		end

	visit_document (a_document: EDL_DOCUMENT)
			-- Visit `a_document'.
		deferred
		end

	leave_document (a_document: EDL_DOCUMENT)
			-- Leave `a_document'.
		deferred
		end

end
