note
	description: "[
		Ancestor class for visitors that translate documents to a plain text
		output format.
		]"
	author: "Bernhard Brodowsky, Severin Heiniger and Stefan Heule"
	date: "$Date$"
	revision: "$Revision$"

deferred class
	EDL_TEXT_TRANSLATOR

inherit
	EDL_VISITOR

feature -- Access

	last_result: STRING
			-- Output string for the current document.

feature -- Basic operations

	translate (a_document: EDL_DOCUMENT)
			-- Translate `a_document' to its HTML representation and
			-- store the result in `last_result'.
		do
			reset
			a_document.accept (Current)
		end

feature {NONE} -- Implementation

	reset
			-- Reset internal state.
		do
			create last_result.make_empty
		ensure
			empty_last_result: last_result.is_empty
		end

end
