note
	description: "[
		Objects that provide combined information about all documents in a document
		collection and manage the names of files created in the output directory.
		]"
	author: "Bernhard Brodowsky, Severin Heiniger and Stefan Heule"
	date: "$Date$"
	revision: "$Revision$"

class
	EDL_LATEX_TRANSLATOR_CONTEXT

inherit
	EDL_TEXT_TRANSLATOR_CONTEXT
		rename
			make as ttc_make
		redefine
			document_file_extension
		end

create
	make

feature {NONE} -- Initialization

	make (a_document_collection: EDL_DOCUMENT_COLLECTION; a_writer: EDL_LATEX_WRITER)
			-- Initialize with `a_document_collection', collecting any information
			-- that is needed later on and set `writer' to `a_writer'.
		do
			ttc_make (a_document_collection)
			writer := a_writer
		ensure
			writer_set: writer = a_writer
		end

feature -- Access

	writer: EDL_LATEX_WRITER
			-- Current latex writer object.

feature {NONE} -- Implementation

	document_file_extension: STRING = "tex"

end
