visit_text_element (a_text_element: EDL_TEXT_ELEMENT)
	local
		internal_tag: EDL_HTML_TAG
		temp_tag: EDL_HTML_TAG
		formatting: HASH_TABLE[BOOLEAN, STRING]
		style_mapping: HASH_TABLE[STRING, STRING]
	do
		if not (not tag_stack.is_empty) then
			tag_stack.compare_objects
		else
			internal_tag := current_tag
			create formatting.make (5)
			formatting.put (a_text_element.is_superscript, "sup")
			formatting.put (a_text_element.is_subscript, "sub")
			formatting.put (a_text_element.is_bold, "b")
			formatting.put (a_text_element.is_italic, "i")
			formatting.put (a_text_element.is_underlined, "u")
			from
				formatting.start
			until
				formatting.after
			loop
				if formatting.item_for_iteration then
					create temp_tag.make (formatting.key_for_iteration)
					internal_tag.extend (temp_tag)
					internal_tag := temp_tag
				end
				formatting.forth
			end
			create style_mapping.make (2)
			if attached a_text_element.color as color then
				style_mapping.put (css_color (color), "color")
			end
			if attached a_text_element.background_color as color then
				style_mapping.put (css_color (color), "background-color")
			end
			if not style_mapping.is_empty then
				temp_tag := "span"
				temp_tag.set_style (style_mapping)
				internal_tag.extend (temp_tag)
				internal_tag := temp_tag
			end
			internal_tag.extend_with_text (a_text_element.text)
		end
	end
